/*
                            SAR Object File IO CallBacks

	Functions:

	int SARSceneLoadProgressCB(
	        void *ptr,
		long file_pos, long file_size
	)

	---

 */

#include <stdio.h>
#include <sys/types.h>
#include "../include/os.h"

#ifdef __MSW__
# include <windows.h>
#else
# include <unistd.h>
#endif

#include <GL/gl.h>

#include "../include/string.h"

#include "gw.h"
#include "menu.h"
#include "sar.h"



/*
 *	Scene load progress callback handler.
 */
int SARSceneLoadProgressCB(
	void *ptr,
	long file_pos, long file_size
)
{
	int n;
	sar_core_struct *core_ptr = (sar_core_struct *)ptr;
	sar_menu_struct *menu_ptr;
	gw_display_struct *display;


	if(core_ptr == NULL)
	    return(0);

	display = core_ptr->display;
	if(display == NULL)
	    return(0);

	/* Get pointer to load simulation progress menu. */
	n = SARMatchMenuByName(
	    core_ptr,
	    SAR_MENU_NAME_LOADING_SIMULATION
	);
	menu_ptr = ((n < 0) ? NULL : core_ptr->menu[n]);
	if(menu_ptr == NULL)
	    return(0);

	if(file_size > 0)
	{
	    SARMenuSetProgressSimple(
		display,
		menu_ptr,
		(double)file_pos / (double)file_size,
		1
	    );
	    GWSwapBuffer(display);
	}

	return(0);
}
